from typing import Dict, List, Tuple, Union
import torch
import torch.nn as nn
import torch.nn.functional as F

from ...recurrent_training.recurrent_memory import RecurrentMemory

# pylint:disable=no-member


class MemformerMemory(RecurrentMemory):
    def __init__(self, memory_states, batch_size: int):
        super().__init__(memory_states, batch_size)

    def to(self, device: torch.device):
        # self.memory_states.to(device)
        self.memory_states = [self.memory_states.to(device) for _ in range(len(self.memory_states))]

    def update(self, new_memory_states) -> RecurrentMemory:
        self.memory_states = new_memory_states

    def chunk(self, chunks: int) -> List[RecurrentMemory]:
        raise NotImplementedError

    def retain_grad(self):
        pass
        # if not self.memory_states.requires_grad:
        #     self.memory_states.requires_grad = True
        # self.memory_states.retain_grad()

    def backward(self, grad):
        raise NotImplementedError
        self.memory_states.backward(grad, retain_graph=True)

    def detach_(self):
        self.memory_states = [self.memory_states[i].detach() for i in range(len(self.memory_states))]

    @property
    def grad(self):
        return self.memory_states[0].grad
